## slicot 5.9.1

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.15.0)
CMAKE_POLICY(SET CMP0048 NEW)

PROJECT(SLICOT VERSION 5.9.1
               LANGUAGES C Fortran)

# Add addtional CMAKE Paths.
LIST(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

# Enforce Out of Source Builds
INCLUDE(OutOfSource)

# Compile Options
OPTION(SLICOT_DEBUG "Enable Debug Symbol generation" OFF)
OPTION(SLICOT_INTEGER8 "Build with 64-bit integers (ILP64)" OFF) # Add ILP64 option

# Enable Testing
IF(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    OPTION(SLICOT_TESTING "Build the SLICOT example programs and tests" ON)
    IF (SLICOT_TESTING)
        INCLUDE(CTest)
        ENABLE_TESTING()
    ENDIF()
ELSE()
    SET(SLICOT_TESTING OFF)
ENDIF()



IF (SLICOT_INTEGER8)
    SET(INTEGER8 ON)
    SET(SLICOT_NAME "slicot64")
    SET(SLICOT_NAME_UC "SLICOT64")
ELSE()
    SET(INTEGER8 OFF)
    SET(SLICOT_NAME "slicot")
    SET(SLICOT_NAME_UC "SLICOT")
ENDIF()

# Enable PIC code by default
SET(CMAKE_POSITION_INDEPENDENT_CODE TRUE)
SET(CMAKE_EXPORT_COMPILE_COMMANDS TRUE)
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

# Output directories
IF(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
   SET(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lib)
   SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lib)
   SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/bin)
ENDIF()

# Configure the Build

INCLUDE(FortranCompilerSettings)
INCLUDE(GNUInstallDirs)

IF (NOT DEFINED BUILD_SHARED_LIBS)
    SET(BUILD_SHARED_LIBS ON)
ENDIF()

# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Release' as none was specified.")
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo" "Coverage")
endif()

# Select the Proper Build Type.
IF ( SLICOT_DEBUG STREQUAL ON OR CMAKE_BUILD_TYPE STREQUAL "Debug"  )
	SET (CMAKE_BUILD_TYPE "Debug")
    SET (SLICOT_DEBUG ON)
	ADD_DEFINITIONS(-DDEBUG)
ENDIF()



# Coverage
set(_is_coverage_build 0)
set(_msg "Checking if build type is 'Coverage'")
message(STATUS "${_msg}")
if(NOT CMAKE_CONFIGURATION_TYPES)
  string(TOLOWER ${CMAKE_BUILD_TYPE} _build_type_lc)
  if(${_build_type_lc} STREQUAL "coverage")
    set(_is_coverage_build 1)
  endif()
endif()
message(STATUS "${_msg}: ${_is_coverage_build}")

if(_is_coverage_build)
  message(STATUS "Adding coverage")
  find_package(codecov)
endif()



# IBM XLF Compilation
IF( CMAKE_Fortran_COMPILER_ID STREQUAL "XL")
	SET(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -qfixed -qnosave")
ENDIF()


IF(INTEGER8)
    MESSAGE(STATUS "8-Byte Integer (ILP64) build.")
    IF(${CMAKE_VERSION} VERSION_LESS "3.22.0")
        MESSAGE(WARNING "8-Byte Integer (ILP64) build requires CMake 3.22 or newer to work properly.")
    ENDIF()
    SET(BLA_SIZEOF_INTEGER 8)
ELSE()
    SET(BLA_SIZEOF_INTEGER 4)
ENDIF()

FIND_PACKAGE(BLAS REQUIRED)
MESSAGE(STATUS "Found BLAS Library: ${BLA_VENDOR} (${BLAS_LIBRARIES})")
FIND_PACKAGE(LAPACK REQUIRED)
MESSAGE(STATUS "Found LAPACK Library: ${BLA_VENDOR} (${LAPACK_LIBRARIES})")

# Compatability with CMAKE < 3.18
if(NOT TARGET BLAS::BLAS)
    add_library(BLAS::BLAS IMPORTED INTERFACE)
    set_property(TARGET BLAS::BLAS PROPERTY INTERFACE_LINK_LIBRARIES ${BLAS_LIBRARIES})
    set_property(TARGET BLAS::BLAS PROPERTY INTERFACE_LINK_OPTIONS ${BLAS_LINKER_FLAGS})
endif()
if(NOT TARGET LAPACK::LAPACK)
    add_library(LAPACK::LAPACK IMPORTED INTERFACE)
    set_property(TARGET LAPACK::LAPACK PROPERTY INTERFACE_LINK_LIBRARIES ${LAPACK_LIBRARIES})
    set_property(TARGET LAPACK::LAPACK PROPERTY INTERFACE_LINK_OPTIONS ${LAPACK_LINKER_FLAGS})
endif()

ADD_SUBDIRECTORY(src)

IF(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR AND SLICOT_TESTING)
    ADD_SUBDIRECTORY(examples)
ENDIF()

# Configure the warning and code coverage suppression file
configure_file(
    "${PROJECT_SOURCE_DIR}/CTestCustom.cmake.in"
  "${PROJECT_BINARY_DIR}/CTestCustom.cmake"
  @ONLY
)



INCLUDE(CMakePackageConfigHelpers)
WRITE_BASIC_PACKAGE_VERSION_FILE(
    ${SLICOT_NAME_UC}ConfigVersion.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY AnyNewerVersion
 )
INSTALL(EXPORT slicot_targets
    FILE ${SLICOT_NAME_UC}Targets.cmake
    NAMESPACE SLICOT::
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${SLICOT_NAME_UC}
)

CONFIGURE_FILE(SLICOTConfig.cmake.in ${SLICOT_NAME_UC}Config.cmake @ONLY)
INSTALL(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/${SLICOT_NAME_UC}Config.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/${SLICOT_NAME_UC}ConfigVersion.cmake"
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${SLICOT_NAME_UC}
    )

CONFIGURE_FILE(slicot.pc.in ${SLICOT_NAME}.pc @ONLY)
INSTALL(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/${SLICOT_NAME}.pc"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

MESSAGE(STATUS "------------ Build Information --------------")
MESSAGE(STATUS "VERSION: ${PROJECT_VERSION} ${FULL_VERSION}")
MESSAGE(STATUS "CMAKE_Fortran_FLAGS:  ${CMAKE_Fortran_FLAGS}")
MESSAGE(STATUS "CMAKE_Fortran_FLAGS_DEBUG:  ${CMAKE_Fortran_FLAGS_DEBUG}")
MESSAGE(STATUS "CMAKE_Fortran_FLAGS_RELEASE:  ${CMAKE_Fortran_FLAGS_RELEASE}")
MESSAGE(STATUS "BLAS Libraries: ${BLAS_LIBRARIES}")
MESSAGE(STATUS "LAPACK Libraries: ${LAPACK_LIBRARIES}")
MESSAGE(STATUS "CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}")
MESSAGE(STATUS "BUILD_SHARED_LIBS: ${BUILD_SHARED_LIBS}")
MESSAGE(STATUS "SLICOT_INTEGER8: ${SLICOT_INTEGER8}")
MESSAGE(STATUS "SLICOT_TESTING: ${SLICOT_TESTING}")
MESSAGE(STATUS "---------------------------------------------")

=== examples/CMakeLists.txt ===
macro(add_slicot_test name src)
    get_filename_component(baseNAME ${src} NAME_WE)
    string(SUBSTRING ${baseNAME} 1 -1 baseNAME)
    set(TEST_INPUT  "${CMAKE_CURRENT_SOURCE_DIR}/data/${baseNAME}.dat")
    set(TEST_RESULT "${CMAKE_CURRENT_SOURCE_DIR}/results/${baseNAME}.res")
    set(TEST_OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${baseNAME}.exa")


    # if(EXISTS "${TEST_INPUT}")
    #     MESSAGE(STATUS "Test Input ${TEST_INPUT} exists")
    # else()
    #     MESSAGE(STATUS "Test Input ${TEST_INPUT} does not exist")
    # endif()
    add_executable(${name} ${src})
    target_link_libraries(${name} SLICOT::slicot)
    if(EXISTS "${TEST_INPUT}")
       if (EXISTS "${TEST_RESULT}")
            add_test(NAME test-${baseNAME} COMMAND "${CMAKE_COMMAND}"
                -DTEST=$<TARGET_FILE:${name}>
                -DINPUT=${TEST_INPUT}
                -DOUTPUT=${TEST_OUTPUT}
                -DRESULT=${TEST_RESULT}
                -DINTDIR=${CMAKE_CFG_INTDIR}
                -P "${CMAKE_CURRENT_SOURCE_DIR}/runtest.cmake")

            set_property(TEST test-${baseNAME} PROPERTY
                ATTACHED_FILES "${TEST_INPUT};${TEST_RESULT};${CMAKE_CURRENT_SOURCE_DIR}/runtest.cmake")
        else()
            add_test(NAME test-${baseNAME} COMMAND "${CMAKE_COMMAND}"
                -DTEST=$<TARGET_FILE:${name}>
                -DINPUT=${TEST_INPUT}
                -DOUTPUT=${TEST_OUTPUT}
                -DINTDIR=${CMAKE_CFG_INTDIR}
                -P "${CMAKE_CURRENT_SOURCE_DIR}/runtest.cmake")
            set_property(TEST test-${baseNAME} PROPERTY
                ATTACHED_FILES "${TEST_INPUT};${CMAKE_CURRENT_SOURCE_DIR}/runtest.cmake")

        endif()
    else()
        add_test(NAME test-${name} COMMAND "${CMAKE_COMMAND}"
            -DTEST=$<TARGET_FILE:${name}>
            -DOUTPUT=${TEST_OUTPUT}
            -DINTDIR=${CMAKE_CFG_INTDIR}
            -P "${LAPACK_SOURCE_DIR}/TESTING/runtest.cmake")
        set_property(TEST test-${baseNAME} PROPERTY
            ATTACHED_FILES "${CMAKE_CURRENT_SOURCE_DIR}/runtest.cmake")


    endif()
endmacro()


add_slicot_test(TAB01MD TAB01MD.f)
add_slicot_test(TAB01ND TAB01ND.f)
add_slicot_test(TAB01OD TAB01OD.f)
add_slicot_test(TAB04MD TAB04MD.f)
add_slicot_test(TAB05MD TAB05MD.f)
add_slicot_test(TAB05ND TAB05ND.f)
add_slicot_test(TAB05OD TAB05OD.f)
add_slicot_test(TAB05PD TAB05PD.f)
add_slicot_test(TAB05QD TAB05QD.f)
add_slicot_test(TAB05RD TAB05RD.f)
add_slicot_test(TAB07MD TAB07MD.f)
add_slicot_test(TAB07ND TAB07ND.f)
add_slicot_test(TAB08ND TAB08ND.f)
add_slicot_test(TAB08NW TAB08NW.f)
add_slicot_test(TAB08NZ TAB08NZ.f)
add_slicot_test(TAB09AD TAB09AD.f)
add_slicot_test(TAB09BD TAB09BD.f)
add_slicot_test(TAB09CD TAB09CD.f)
add_slicot_test(TAB09DD TAB09DD.f)
add_slicot_test(TAB09ED TAB09ED.f)
add_slicot_test(TAB09FD TAB09FD.f)
add_slicot_test(TAB09GD TAB09GD.f)
add_slicot_test(TAB09HD TAB09HD.f)
add_slicot_test(TAB09ID TAB09ID.f)
add_slicot_test(TAB09JD TAB09JD.f)
add_slicot_test(TAB09KD TAB09KD.f)
add_slicot_test(TAB09MD TAB09MD.f)
add_slicot_test(TAB09ND TAB09ND.f)
add_slicot_test(TAB13AD TAB13AD.f)
add_slicot_test(TAB13BD TAB13BD.f)
add_slicot_test(TAB13CD TAB13CD.f)
add_slicot_test(TAB13DD TAB13DD.f)
add_slicot_test(TAB13ED TAB13ED.f)
add_slicot_test(TAB13FD TAB13FD.f)
add_slicot_test(TAB13ID TAB13ID.f)
add_slicot_test(TAB13MD TAB13MD.f)
add_slicot_test(TAG08BD TAG08BD.f)
add_slicot_test(TAG08BZ TAG08BZ.f)
add_slicot_test(TBB01AD TBB01AD.f)
add_slicot_test(TBB02AD TBB02AD.f)
add_slicot_test(TBB03AD TBB03AD.f)
add_slicot_test(TBB04AD TBB04AD.f)
add_slicot_test(TBD01AD TBD01AD.f)
add_slicot_test(TBD02AD TBD02AD.f)
add_slicot_test(TDE01OD TDE01OD.f)
add_slicot_test(TDE01PD TDE01PD.f)
add_slicot_test(TDF01MD TDF01MD.f)
add_slicot_test(TDG01MD TDG01MD.f)
add_slicot_test(TDG01ND TDG01ND.f)
add_slicot_test(TDG01OD TDG01OD.f)
add_slicot_test(TDK01MD TDK01MD.f)
add_slicot_test(TFB01QD TFB01QD.f)
add_slicot_test(TFB01RD TFB01RD.f)
add_slicot_test(TFB01SD TFB01SD.f)
add_slicot_test(TFB01TD TFB01TD.f)
add_slicot_test(TFB01VD TFB01VD.f)
add_slicot_test(TFD01AD TFD01AD.f)
add_slicot_test(TIB01AD TIB01AD.f)
add_slicot_test(TIB01BD TIB01BD.f)
add_slicot_test(TIB01CD TIB01CD.f)
add_slicot_test(TIB03AD TIB03AD.f)
add_slicot_test(TIB03BD TIB03BD.f)
add_slicot_test(TMB01TD TMB01TD.f)
add_slicot_test(TMB02CD TMB02CD.f)
add_slicot_test(TMB02DD TMB02DD.f)
add_slicot_test(TMB02ED TMB02ED.f)
add_slicot_test(TMB02FD TMB02FD.f)
add_slicot_test(TMB02GD TMB02GD.f)
add_slicot_test(TMB02HD TMB02HD.f)
add_slicot_test(TMB02ID TMB02ID.f)
add_slicot_test(TMB02JD TMB02JD.f)
add_slicot_test(TMB02JX TMB02JX.f)
add_slicot_test(TMB02KD TMB02KD.f)
add_slicot_test(TMB02MD TMB02MD.f)
add_slicot_test(TMB02ND TMB02ND.f)
add_slicot_test(TMB02QD TMB02QD.f)
add_slicot_test(TMB02SD TMB02SD.f)
add_slicot_test(TMB02VD TMB02VD.f)
add_slicot_test(TMB03BD TMB03BD.f)
add_slicot_test(TMB03BZ TMB03BZ.f)
add_slicot_test(TMB03FZ TMB03FZ.f)
add_slicot_test(TMB03KD TMB03KD.f)
add_slicot_test(TMB03LD TMB03LD.f)
add_slicot_test(TMB03LF TMB03LF.f)
add_slicot_test(TMB03LZ TMB03LZ.f)
add_slicot_test(TMB03MD TMB03MD.f)
add_slicot_test(TMB03ND TMB03ND.f)
add_slicot_test(TMB03OD TMB03OD.f)
add_slicot_test(TMB03PD TMB03PD.f)
add_slicot_test(TMB03QD TMB03QD.f)
add_slicot_test(TMB03QG TMB03QG.f)
add_slicot_test(TMB03RD TMB03RD.f)
add_slicot_test(TMB03SD TMB03SD.f)
add_slicot_test(TMB03TD TMB03TD.f)
add_slicot_test(TMB03UD TMB03UD.f)
add_slicot_test(TMB03VD TMB03VD.f)
add_slicot_test(TMB03WD TMB03WD.f)
add_slicot_test(TMB03XD TMB03XD.f)
add_slicot_test(TMB03XP TMB03XP.f)
add_slicot_test(TMB03XZ TMB03XZ.f)
add_slicot_test(TMB03ZD TMB03ZD.f)
add_slicot_test(TMB04AD TMB04AD.f)
add_slicot_test(TMB04AZ TMB04AZ.f)
add_slicot_test(TMB04BD TMB04BD.f)
add_slicot_test(TMB04BZ TMB04BZ.f)
add_slicot_test(TMB04DD TMB04DD.f)
add_slicot_test(TMB04DL TMB04DL.f)
add_slicot_test(TMB04DP TMB04DP.f)
add_slicot_test(TMB04DS TMB04DS.f)
add_slicot_test(TMB04DY TMB04DY.f)
add_slicot_test(TMB04DZ TMB04DZ.f)
add_slicot_test(TMB04ED TMB04ED.f)
add_slicot_test(TMB04FD TMB04FD.f)
add_slicot_test(TMB04GD TMB04GD.f)
add_slicot_test(TMB04MD TMB04MD.f)
add_slicot_test(TMB04OD TMB04OD.f)
add_slicot_test(TMB04PB TMB04PB.f)
add_slicot_test(TMB04PU TMB04PU.f)
add_slicot_test(TMB04TB TMB04TB.f)
add_slicot_test(TMB04TS TMB04TS.f)
add_slicot_test(TMB04UD TMB04UD.f)
add_slicot_test(TMB04VD TMB04VD.f)
add_slicot_test(TMB04XD TMB04XD.f)
add_slicot_test(TMB04YD TMB04YD.f)
add_slicot_test(TMB04ZD TMB04ZD.f)
add_slicot_test(TMB05MD TMB05MD.f)
add_slicot_test(TMB05ND TMB05ND.f)
add_slicot_test(TMB05OD TMB05OD.f)
add_slicot_test(TMB4DLZ TMB4DLZ.f)
add_slicot_test(TMB4DPZ TMB4DPZ.f)
add_slicot_test(TMC01MD TMC01MD.f)
add_slicot_test(TMC01ND TMC01ND.f)
add_slicot_test(TMC01OD TMC01OD.f)
add_slicot_test(TMC01PD TMC01PD.f)
add_slicot_test(TMC01QD TMC01QD.f)
add_slicot_test(TMC01RD TMC01RD.f)
add_slicot_test(TMC01SD TMC01SD.f)
add_slicot_test(TMC01TD TMC01TD.f)
add_slicot_test(TMC01VD TMC01VD.f)
add_slicot_test(TMC01WD TMC01WD.f)
add_slicot_test(TMC01XD TMC01XD.f)
add_slicot_test(TMC03MD TMC03MD.f)
add_slicot_test(TMC03ND TMC03ND.f)
add_slicot_test(TMD03AD TMD03AD.f)
add_slicot_test(TMD03BD TMD03BD.f)
add_slicot_test(TSB01BD TSB01BD.f)
add_slicot_test(TSB01DD TSB01DD.f)
add_slicot_test(TSB01MD TSB01MD.f)
add_slicot_test(TSB02MD TSB02MD.f)
add_slicot_test(TSB02ND TSB02ND.f)
add_slicot_test(TSB02OD TSB02OD.f)
add_slicot_test(TSB02PD TSB02PD.f)
add_slicot_test(TSB02QD TSB02QD.f)
add_slicot_test(TSB02RD TSB02RD.f)
add_slicot_test(TSB02SD TSB02SD.f)
add_slicot_test(TSB03MD TSB03MD.f)
add_slicot_test(TSB03OD TSB03OD.f)
add_slicot_test(TSB03QD TSB03QD.f)
add_slicot_test(TSB03SD TSB03SD.f)
add_slicot_test(TSB03TD TSB03TD.f)
add_slicot_test(TSB03UD TSB03UD.f)
add_slicot_test(TSB04MD TSB04MD.f)
add_slicot_test(TSB04ND TSB04ND.f)
add_slicot_test(TSB04OD TSB04OD.f)
add_slicot_test(TSB04PD TSB04PD.f)
add_slicot_test(TSB04QD TSB04QD.f)
add_slicot_test(TSB04RD TSB04RD.f)
add_slicot_test(TSB06ND TSB06ND.f)
add_slicot_test(TSB08CD TSB08CD.f)
add_slicot_test(TSB08DD TSB08DD.f)
add_slicot_test(TSB08ED TSB08ED.f)
add_slicot_test(TSB08FD TSB08FD.f)
add_slicot_test(TSB08MD TSB08MD.f)
add_slicot_test(TSB08ND TSB08ND.f)
add_slicot_test(TSB09MD TSB09MD.f)
add_slicot_test(TSB10DD TSB10DD.f)
add_slicot_test(TSB10ED TSB10ED.f)
add_slicot_test(TSB10FD TSB10FD.f)
add_slicot_test(TSB10HD TSB10HD.f)
add_slicot_test(TSB10ID TSB10ID.f)
add_slicot_test(TSB10KD TSB10KD.f)
add_slicot_test(TSB10ZD TSB10ZD.f)
add_slicot_test(TSB16AD TSB16AD.f)
add_slicot_test(TSB16BD TSB16BD.f)
add_slicot_test(TSB16CD TSB16CD.f)
add_slicot_test(TSG02AD TSG02AD.f)
add_slicot_test(TSG02ND TSG02ND.f)
add_slicot_test(TSG03AD TSG03AD.f)
add_slicot_test(TSG03BD TSG03BD.f)
add_slicot_test(TTB01ID TTB01ID.f)
add_slicot_test(TTB01IZ TTB01IZ.f)
add_slicot_test(TTB01KD TTB01KD.f)
add_slicot_test(TTB01LD TTB01LD.f)
add_slicot_test(TTB01MD TTB01MD.f)
add_slicot_test(TTB01ND TTB01ND.f)
add_slicot_test(TTB01PD TTB01PD.f)
add_slicot_test(TTB01PX TTB01PX.f)
add_slicot_test(TTB01TD TTB01TD.f)
add_slicot_test(TTB01UD TTB01UD.f)
add_slicot_test(TTB01UY TTB01UY.f)
add_slicot_test(TTB01WD TTB01WD.f)
add_slicot_test(TTB01WX TTB01WX.f)
add_slicot_test(TTB01ZD TTB01ZD.f)
add_slicot_test(TTB03AD TTB03AD.f)
add_slicot_test(TTB04AD TTB04AD.f)
add_slicot_test(TTB04BD TTB04BD.f)
add_slicot_test(TTB04CD TTB04CD.f)
add_slicot_test(TTB05AD TTB05AD.f)
add_slicot_test(TTC01OD TTC01OD.f)
add_slicot_test(TTC04AD TTC04AD.f)
add_slicot_test(TTC05AD TTC05AD.f)
add_slicot_test(TTD03AD TTD03AD.f)
add_slicot_test(TTD04AD TTD04AD.f)
add_slicot_test(TTD05AD TTD05AD.f)
add_slicot_test(TTF01MD TTF01MD.f)
add_slicot_test(TTF01ND TTF01ND.f)
add_slicot_test(TTF01OD TTF01OD.f)
add_slicot_test(TTF01PD TTF01PD.f)
add_slicot_test(TTF01QD TTF01QD.f)
add_slicot_test(TTF01RD TTF01RD.f)
add_slicot_test(TTG01AD TTG01AD.f)
add_slicot_test(TTG01AZ TTG01AZ.f)
add_slicot_test(TTG01CD TTG01CD.f)
add_slicot_test(TTG01DD TTG01DD.f)
add_slicot_test(TTG01ED TTG01ED.f)
add_slicot_test(TTG01FD TTG01FD.f)
add_slicot_test(TTG01FZ TTG01FZ.f)
add_slicot_test(TTG01GD TTG01GD.f)
add_slicot_test(TTG01HD TTG01HD.f)
add_slicot_test(TTG01ID TTG01ID.f)
add_slicot_test(TTG01JD TTG01JD.f)
add_slicot_test(TTG01JY TTG01JY.f)
add_slicot_test(TTG01LD TTG01LD.f)
add_slicot_test(TTG01MD TTG01MD.f)
add_slicot_test(TTG01ND TTG01ND.f)
add_slicot_test(TTG01PD TTG01PD.f)
add_slicot_test(TTG01QD TTG01QD.f)
add_slicot_test(TUD01BD TUD01BD.f)
add_slicot_test(TUD01CD TUD01CD.f)
add_slicot_test(TUD01DD TUD01DD.f)
add_slicot_test(TUD01MD TUD01MD.f)
add_slicot_test(TUD01ND TUD01ND.f)

=== src/CMakeLists.txt ===
SET(SOURCES
    AB01MD.f AB01ND.f AB01OD.f AB04MD.f AB05MD.f AB05ND.f AB05OD.f
    AB05PD.f AB05QD.f AB05RD.f AB05SD.f AB07MD.f AB07ND.f AB08MD.f
    AB08MZ.f AB08ND.f AB08NW.f AB08NX.f AB08NY.f AB08NZ.f AB09AD.f
    AB09AX.f AB09BD.f AB09BX.f AB09CD.f AB09CX.f AB09DD.f AB09ED.f
    AB09FD.f AB09GD.f AB09HD.f AB09HX.f AB09HY.f AB09ID.f AB09IX.f
    AB09IY.f AB09JD.f AB09JV.f AB09JW.f AB09JX.f AB09KD.f AB09KX.f
    AB09MD.f AB09ND.f AB13AD.f AB13AX.f AB13BD.f AB13CD.f AB13DD.f
    AB13DX.f AB13ED.f AB13FD.f AB13HD.f AB13ID.f AB13MD.f AB8NXZ.f
    AG07BD.f AG08BD.f AG08BY.f AG08BZ.f AG8BYZ.f

    BB01AD.f BB02AD.f BB03AD.f BB04AD.f BD01AD.f BD02AD.f

    DE01OD.f DE01PD.f DF01MD.f DG01MD.f DG01ND.f DG01NY.f DG01OD.f
    DK01MD.f

    FB01QD.f FB01RD.f FB01SD.f FB01TD.f FB01VD.f FD01AD.f

    IB01AD.f IB01BD.f IB01CD.f IB01MD.f IB01MY.f IB01ND.f IB01OD.f
    IB01OY.f IB01PD.f IB01PX.f IB01PY.f IB01QD.f IB01RD.f IB03AD.f
    IB03BD.f

    MA01AD.f MA01BD.f MA01BZ.f MA01CD.f MA01DD.f MA01DZ.f MA02AD.f MA02AZ.f
    MA02BD.f MA02BZ.f MA02CD.f MA02CZ.f MA02DD.f MA02ED.f MA02ES.f MA02EZ.f
    MA02FD.f MA02GD.f MA02GZ.f MA02HD.f MA02HZ.f MA02ID.f MA02IZ.f MA02JD.f
    MA02JZ.f MA02MD.f MA02MZ.f MA02NZ.f MA02OD.f MA02OZ.f MA02PD.f MA02PZ.f
    MA02RD.f MA02SD.f MB01KD.f MB01LD.f MB01MD.f MB01ND.f MB01OC.f MB01OD.f
    MB01OE.f MB01OH.f MB01OO.f MB01OS.f MB01OT.f MB01PD.f MB01QD.f MB01RB.f
    MB01RD.f MB01RH.f MB01RT.f MB01RU.f MB01RW.f MB01RX.f MB01RY.f MB01SD.f
    MB01SS.f MB01TD.f MB01UD.f MB01UW.f MB01UX.f MB01UY.f MB01UZ.f MB01VD.f
    MB01WD.f MB01XD.f MB01XY.f MB01YD.f MB01ZD.f MB02CD.f MB02CU.f MB02CV.f
    MB02CX.f MB02CY.f MB02DD.f MB02ED.f MB02FD.f MB02GD.f MB02HD.f MB02ID.f
    MB02JD.f MB02JX.f MB02KD.f MB02MD.f MB02ND.f MB02NY.f MB02OD.f MB02PD.f
    MB02QD.f MB02QY.f MB02RD.f MB02RZ.f MB02SD.f MB02SZ.f MB02TD.f MB02TZ.f
    MB02UD.f MB02UU.f MB02UV.f MB02UW.f MB02VD.f MB02WD.f MB02XD.f MB02YD.f
    MB03AB.f MB03AD.f MB03AE.f MB03AF.f MB03AG.f MB03AH.f MB03AI.f MB03BA.f
    MB03BB.f MB03BC.f MB03BD.f MB03BE.f MB03BF.f MB03BG.f MB03BZ.f MB03CD.f
    MB03CZ.f MB03DD.f MB03DZ.f MB03ED.f MB03FD.f MB03FZ.f MB03GD.f MB03GZ.f
    MB03HD.f MB03HZ.f MB03ID.f MB03IZ.f MB03JD.f MB03JP.f MB03JZ.f MB03KA.f
    MB03KB.f MB03KC.f MB03KD.f MB03KE.f MB03LD.f MB03LF.f MB03LP.f MB03LZ.f
    MB03MD.f MB03MY.f MB03ND.f MB03NY.f MB03OD.f MB03OY.f MB03PD.f MB03PY.f
    MB03QD.f MB03QG.f MB03QV.f MB03QW.f MB03QX.f MB03QY.f MB03RD.f MB03RW.f
    MB03RX.f MB03RY.f MB03RZ.f MB03SD.f MB03TD.f MB03TS.f MB03UD.f MB03VD.f
    MB03VW.f MB03VY.f MB03WA.f MB03WD.f MB03WX.f MB03XD.f MB03XP.f MB03XS.f
    MB03XU.f MB03XZ.f MB03YA.f MB03YD.f MB03YT.f MB03ZA.f MB03ZD.f MB04AD.f
    MB04AZ.f MB04BD.f MB04BP.f MB04BZ.f MB04CD.f MB04DB.f MB04DD.f MB04DI.f
    MB04DL.f MB04DP.f MB04DS.f MB04DY.f MB04DZ.f MB04ED.f MB04FD.f MB04FP.f
    MB04GD.f MB04HD.f MB04ID.f MB04IY.f MB04IZ.f MB04JD.f MB04KD.f MB04LD.f
    MB04MD.f MB04ND.f MB04NY.f MB04OD.f MB04OW.f MB04OX.f MB04OY.f MB04PA.f
    MB04PB.f MB04PU.f MB04PY.f MB04QB.f MB04QC.f MB04QF.f MB04QS.f MB04QU.f
    MB04RB.f MB04RD.f MB04RS.f MB04RT.f MB04RU.f MB04RV.f MB04RW.f MB04RZ.f
    MB04SU.f MB04TB.f MB04TS.f MB04TT.f MB04TU.f MB04TV.f MB04TW.f MB04TX.f
    MB04TY.f MB04UD.f MB04VD.f MB04VX.f MB04WD.f MB04WP.f MB04WR.f MB04WU.f
    MB04XD.f MB04XY.f MB04YD.f MB04YW.f MB04ZD.f MB05MD.f MB05MY.f MB05ND.f
    MB05OD.f MB05OY.f MB3JZP.f MB3LZP.f MB3OYZ.f MB3PYZ.f MB4DBZ.f MB4DLZ.f
    MB4DPZ.f MC01MD.f MC01ND.f MC01OD.f MC01PD.f MC01PY.f MC01QD.f MC01RD.f
    MC01SD.f MC01SW.f MC01SX.f MC01SY.f MC01TD.f MC01VD.f MC01WD.f MC01XD.f
    MC03MD.f MC03ND.f MC03NX.f MC03NY.f MD03AD.f MD03BA.f MD03BB.f MD03BD.f
    MD03BF.f MD03BX.f

    MD03BY.f NF01AD.f NF01AY.f NF01BA.f NF01BB.f NF01BD.f NF01BE.f NF01BF.f
    NF01BP.f NF01BQ.f NF01BR.f NF01BS.f NF01BU.f NF01BV.f NF01BW.f NF01BX.f
    NF01BY.f

    SB01BD.f SB01BX.f SB01BY.f SB01DD.f SB01FY.f SB01MD.f SB02CX.f SB02MD.f
    SB02MR.f SB02MS.f SB02MT.f SB02MU.f SB02MV.f SB02MW.f SB02MX.f SB02ND.f
    SB02OD.f SB02OU.f SB02OV.f SB02OW.f SB02OX.f SB02OY.f SB02PD.f SB02QD.f
    SB02RD.f SB02RU.f SB02SD.f SB03MD.f SB03MU.f SB03MV.f SB03MW.f SB03MX.f
    SB03MY.f SB03OD.f SB03OR.f SB03OS.f SB03OT.f SB03OU.f SB03OV.f SB03OY.f
    SB03OZ.f SB03PD.f SB03QD.f SB03QX.f SB03QY.f SB03RD.f SB03SD.f SB03SX.f
    SB03SY.f SB03TD.f SB03UD.f SB04MD.f SB04MR.f SB04MU.f SB04MW.f SB04MY.f
    SB04ND.f SB04NV.f SB04NW.f SB04NX.f SB04NY.f SB04OD.f SB04OW.f SB04PD.f
    SB04PX.f SB04PY.f SB04QD.f SB04QR.f SB04QU.f SB04QY.f SB04RD.f SB04RV.f
    SB04RW.f SB04RX.f SB04RY.f SB06ND.f SB08CD.f SB08DD.f SB08ED.f SB08FD.f
    SB08GD.f SB08HD.f SB08MD.f SB08MY.f SB08ND.f SB08NY.f SB09MD.f SB10AD.f
    SB10DD.f SB10ED.f SB10FD.f SB10HD.f SB10ID.f SB10JD.f SB10KD.f SB10LD.f
    SB10MD.f SB10PD.f SB10QD.f SB10RD.f SB10SD.f SB10TD.f SB10UD.f SB10VD.f
    SB10WD.f SB10YD.f SB10ZD.f SB10ZP.f SB16AD.f SB16AY.f SB16BD.f SB16CD.f
    SB16CY.f SG02AD.f SG02CV.f SG02CW.f SG02CX.f SG02ND.f SG03AD.f SG03AX.f
    SG03AY.f SG03BD.f SG03BR.f SG03BS.f SG03BT.f SG03BU.f SG03BV.f SG03BW.f
    SG03BX.f SG03BY.f SG03BZ.f TB01ID.f TB01IZ.f TB01KD.f TB01KX.f TB01LD.f

    TB01MD.f TB01ND.f TB01PD.f TB01PX.f TB01TD.f TB01TY.f TB01UD.f TB01UX.f
    TB01UY.f TB01VD.f TB01VY.f TB01WD.f TB01WX.f TB01XD.f TB01XZ.f TB01YD.f
    TB01ZD.f TB03AD.f TB03AY.f TB04AD.f TB04AY.f TB04BD.f TB04BV.f TB04BW.f
    TB04BX.f TB04CD.f TB05AD.f TC01OD.f TC04AD.f TC05AD.f TD03AD.f TD03AY.f
    TD04AD.f TD05AD.f TF01MD.f TF01MX.f TF01MY.f TF01ND.f TF01OD.f TF01PD.f
    TF01QD.f TF01RD.f TG01AD.f TG01AZ.f TG01BD.f TG01CD.f TG01DD.f TG01ED.f
    TG01FD.f TG01FZ.f TG01GD.f TG01HD.f TG01HU.f TG01HX.f TG01HY.f TG01ID.f
    TG01JD.f TG01JY.f TG01KD.f TG01KZ.f TG01LD.f TG01LY.f TG01MD.f TG01ND.f
    TG01NX.f TG01OA.f TG01OB.f TG01OD.f TG01OZ.f TG01PD.f TG01QD.f TG01WD.f

    UD01BD.f UD01CD.f UD01DD.f UD01MD.f UD01MZ.f UD01ND.f UE01MD.f

    delctg.f select.f zelctg.f
    )


# Check for deprecated LAPACK Symbols
INCLUDE(CheckFortranFunctionExists)

MACRO(ADD_ROUTINE_IF_REQUIRED ROUTINE VAR SOURCE_FILE)
    SET(_CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES})
    SET(CMAKE_REQUIRED_LIBRARIES PRIVATE BLAS::BLAS LAPACK::LAPACK)

    Check_Fortran_Function_Exists(${ROUTINE} ${VAR})
    IF (NOT ${VAR})
        MESSAGE(STATUS "Add ${SOURCE_FILE} to library.")
        SET(SOURCES ${SOURCES} ${SOURCE_FILE})
    ENDIF()
    SET(CMAKE_REQUIRED_LIBRARIES ${_CMAKE_REQUIRED_LIBRARIES})
ENDMACRO()

ADD_ROUTINE_IF_REQUIRED(dgegs HAVE_DGEGS lapack_aux/dgegs.f)
ADD_ROUTINE_IF_REQUIRED(zgegs HAVE_ZGEGS lapack_aux/zgegs.f)
ADD_ROUTINE_IF_REQUIRED(dlatzm HAVE_DLAZTM lapack_aux/dlatzm.f)
ADD_ROUTINE_IF_REQUIRED(zlatzm HAVE_ZLAZTM lapack_aux/zlatzm.f)
ADD_ROUTINE_IF_REQUIRED(dgegv HAVE_DGEGV lapack_aux/dgegv.f)
ADD_ROUTINE_IF_REQUIRED(zgegv HAVE_ZGEGV lapack_aux/zgegv.f)

# Setup the library.

ADD_LIBRARY(slicot ${SOURCES})
TARGET_LINK_LIBRARIES(slicot PUBLIC LAPACK::LAPACK BLAS::BLAS)
SET_PROPERTY(TARGET slicot PROPERTY VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH})
SET_PROPERTY(TARGET slicot PROPERTY SOVERSION ${PROJECT_VERSION_MAJOR})
SET_PROPERTY(TARGET slicot PROPERTY OUTPUT_NAME ${SLICOT_NAME})

if(_is_coverage_build)
  target_link_libraries(slicot PRIVATE gcov)
  add_coverage(slicot)
endif()




ADD_LIBRARY(SLICOT::slicot ALIAS slicot)

INSTALL(TARGETS slicot
        EXPORT  slicot_targets
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        )

=== examples/cmake-how-to-example/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
PROJECT(SLICOTTEST LANGUAGES C Fortran)

FIND_PACKAGE(SLICOT REQUIRED)

ADD_EXECUTABLE(TAB01MD TAB01MD.f)
TARGET_LINK_LIBRARIES(TAB01MD SLICOT::slicot)

=== debian/changelog ===
slicot (5.9.1-2) unstable; urgency=medium

  * Do not build ILP64 packages on 32-bit architectures

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 17 Nov 2025 10:14:22 +0100

slicot (5.9.1-1) experimental; urgency=medium

  * New upstream version 5.9.1
  * d/copyright: reflect upstream changes
  * New ILP64 packages and move to CMake build system
    + d/rules: rewrite using new CMake build system
    + SOVERSION bump from 0 to 5 for libslicot, to reflect the SOVERSION in the
      new build system
    + new libslicot64-5 and libslicot64-dev packages for ILP64
    + new libslicot64-pic package that provides the ILP64 PIC version that was
      formerly in libslicot-pic
    + no-pic-by-default.patch: new patch, to ensure that static libraries in
      -dev packages are not compiled with PIC
    + run the testsuite at build time
  * d/control: use proper team name in Maintainer field
  * Drop “Rules-Requires-Root: no”, which is now the default
  * d/watch: upgrade to format version 5
  * d/upstream/metadata: drop non-standard fields
  * libslicot-doc: ship CONTRIBUTING.md, KNOWN_ISSUES.md and CITATION.cff
  * Ship ReleaseNotes.md as upstream changelog
  * libslicot-doc: adapt to new location of libindex.html
  * Bump Standards-Version to 4.7.2

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 15 Nov 2025 17:49:36 +0100

=== debian/control ===
Source: slicot
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Sébastien Villemot <sebastien@debian.org>
Build-Depends: debhelper-compat (= 13)
Build-Depends-Arch: cmake,
                    gfortran,
                    libblas-dev,
                    liblapack-dev,
                    libblas64-dev [alpha amd64 arm64 hurd-amd64 loong64 mips64el ppc64 ppc64el riscv64 s390x sparc64],
                    liblapack64-dev [alpha amd64 arm64 hurd-amd64 loong64 mips64el ppc64 ppc64el riscv64 s390x sparc64]
Standards-Version: 4.7.2
Section: libs
Homepage: https://www.slicot.org
Vcs-Git: https://salsa.debian.org/science-team/slicot.git
Vcs-Browser: https://salsa.debian.org/science-team/slicot

Package: libslicot5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: numerical algorithms from systems and control theory (shared library)
 SLICOT (Subroutine Library In COntrol Theory) is a general purpose basic
 mathematical library for control theoretical computations. The library
 provides tools to perform essential system analysis and synthesis tasks. The
 main emphasis in SLICOT is on numerical reliability of implemented algorithms
 and the numerical robustness and efficiency of routines. Providing algorithmic
 flexibility and the use of rigorous implementation and documentation standards
 are other SLICOT features.
 .
 SLICOT is written is Fortran 77 and builds upon the numerical linear algebra
 routines from BLAS (Basic Linear Algebra Subroutines) and LAPACK (Linear
 Algebra PACKage).
 .
 This package contains a shared version of the library.

Package: libslicot64-5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: numerical algorithms from systems and control theory (shared library, ILP64)
 SLICOT (Subroutine Library In COntrol Theory) is a general purpose basic
 mathematical library for control theoretical computations. The library
 provides tools to perform essential system analysis and synthesis tasks. The
 main emphasis in SLICOT is on numerical reliability of implemented algorithms
 and the numerical robustness and efficiency of routines. Providing algorithmic
 flexibility and the use of rigorous implementation and documentation standards
 are other SLICOT features.
 .
 SLICOT is written is Fortran 77 and builds upon the numerical linear algebra
 routines from BLAS (Basic Linear Algebra Subroutines) and LAPACK (Linear
 Algebra PACKage).
 .
 This package contains a shared version of the library with 64-bit integers.

Package: libslicot-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libslicot5 (= ${binary:Version}),
         libblas-dev,
         liblapack-dev,
         ${misc:Depends}
Suggests: libslicot-doc
Description: numerical algorithms from systems and control theory (static library)
 SLICOT (Subroutine Library In COntrol Theory) is a general purpose basic
 mathematical library for control theoretical computations. The library
 provides tools to perform essential system analysis and synthesis tasks. The
 main emphasis in SLICOT is on numerical reliability of implemented algorithms
 and the numerical robustness and efficiency of routines. Providing algorithmic
 flexibility and the use of rigorous implementation and documentation standards
 are other SLICOT features.
 .
 SLICOT is written is Fortran 77 and builds upon the numerical linear algebra
 routines from BLAS (Basic Linear Algebra Subroutines) and LAPACK (Linear
 Algebra PACKage).
 .
 This package contains a static version of the library.

Package: libslicot64-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libslicot64-5 (= ${binary:Version}),
         libblas64-dev,
         liblapack64-dev,
         ${misc:Depends}
Suggests: libslicot-doc
Description: numerical algorithms from systems and control theory (static library, ILP64)
 SLICOT (Subroutine Library In COntrol Theory) is a general purpose basic
 mathematical library for control theoretical computations. The library
 provides tools to perform essential system analysis and synthesis tasks. The
 main emphasis in SLICOT is on numerical reliability of implemented algorithms
 and the numerical robustness and efficiency of routines. Providing algorithmic
 flexibility and the use of rigorous implementation and documentation standards
 are other SLICOT features.
 .
 SLICOT is written is Fortran 77 and builds upon the numerical linear algebra
 routines from BLAS (Basic Linear Algebra Subroutines) and LAPACK (Linear
 Algebra PACKage).
 .
 This package contains a static version of the library with 64-bit integers.

Package: libslicot-pic
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}
Breaks: dynare-matlab (<= 6.4-3)
Description: numerical algorithms from systems and control theory (static PIC library)
 SLICOT (Subroutine Library In COntrol Theory) is a general purpose basic
 mathematical library for control theoretical computations. The library
 provides tools to perform essential system analysis and synthesis tasks. The
 main emphasis in SLICOT is on numerical reliability of implemented algorithms
 and the numerical robustness and efficiency of routines. Providing algorithmic
 flexibility and the use of rigorous implementation and documentation standards
 are other SLICOT features.
 .
 SLICOT is written is Fortran 77 and builds upon the numerical linear algebra
 routines from BLAS (Basic Linear Algebra Subroutines) and LAPACK (Linear
 Algebra PACKage).
 .
 This package contains a static version of the library compiled with position
 independent code (PIC). This package is provided for other packages to create
 their own dynamic objects. You normally do not need it, unless you have
 special needs.

Package: libslicot64-pic
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}
Breaks: libslicot-pic (<< 5.9.1-1~)
Replaces: libslicot-pic (<< 5.9.1-1~)
Description: numerical algorithms from systems and control theory (static PIC library, ILP64)
 SLICOT (Subroutine Library In COntrol Theory) is a general purpose basic
 mathematical library for control theoretical computations. The library
 provides tools to perform essential system analysis and synthesis tasks. The
 main emphasis in SLICOT is on numerical reliability of implemented algorithms
 and the numerical robustness and efficiency of routines. Providing algorithmic
 flexibility and the use of rigorous implementation and documentation standards
 are other SLICOT features.
 .
 SLICOT is written is Fortran 77 and builds upon the numerical linear algebra
 routines from BLAS (Basic Linear Algebra Subroutines) and LAPACK (Linear
 Algebra PACKage).
 .
 This package contains a static version of the library compiled with position
 independent code (PIC) and 64-bit integers. This package is provided for other
 packages to create their own dynamic objects. You normally do not need it,
 unless you have special needs.

Package: libslicot-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: libslicot-dev,
          libslicot64-dev
Multi-Arch: foreign
Description: numerical algorithms from systems and control theory (documentation)
 SLICOT (Subroutine Library In COntrol Theory) is a general purpose basic
 mathematical library for control theoretical computations. The library
 provides tools to perform essential system analysis and synthesis tasks. The
 main emphasis in SLICOT is on numerical reliability of implemented algorithms
 and the numerical robustness and efficiency of routines. Providing algorithmic
 flexibility and the use of rigorous implementation and documentation standards
 are other SLICOT features.
 .
 SLICOT is written is Fortran 77 and builds upon the numerical linear algebra
 routines from BLAS (Basic Linear Algebra Subroutines) and LAPACK (Linear
 Algebra PACKage).
 .
 This package contains the documentation of all the routines. It also contains
 associated example programs, data and results for many routines.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Get compilation flags from dpkg-buildflags
include /usr/share/dpkg/default.mk

ifneq (64,$(DEB_HOST_ARCH_BITS))
export DH_OPTIONS = -Nlibslicot64-5 -Nlibslicot64-dev -Nlibslicot64-pic
endif

%:
	dh $@

override_dh_auto_configure-arch:
	dh_auto_configure -Bbuild-32-shared -- \
		-DBLA_VENDOR=Generic -DSLICOT_INTEGER8=OFF
	dh_auto_configure -Bbuild-32-static -- \
		-DBLA_VENDOR=Generic -DSLICOT_INTEGER8=OFF \
		-DBUILD_SHARED_LIBS=OFF \
		-DSLICOT_TESTING=OFF
	dh_auto_configure -Bbuild-32-pic -- \
		-DBLA_VENDOR=Generic -DSLICOT_INTEGER8=OFF \
		-DBUILD_SHARED_LIBS=OFF -DCMAKE_POSITION_INDEPENDENT_CODE=TRUE \
		-DSLICOT_TESTING=OFF
ifeq (64,$(DEB_HOST_ARCH_BITS))
	dh_auto_configure -Bbuild-64-shared -- \
		-DBLA_VENDOR=Generic -DSLICOT_INTEGER8=ON
	dh_auto_configure -Bbuild-64-static -- \
		-DBLA_VENDOR=Generic -DSLICOT_INTEGER8=ON \
		-DBUILD_SHARED_LIBS=OFF \
		-DSLICOT_TESTING=OFF
	dh_auto_configure -Bbuild-64-pic -- \
		-DBLA_VENDOR=Generic -DSLICOT_INTEGER8=ON \
		-DBUILD_SHARED_LIBS=OFF -DCMAKE_POSITION_INDEPENDENT_CODE=TRUE \
		-DSLICOT_TESTING=OFF
endif

override_dh_auto_configure-indep:

override_dh_auto_build-arch:
	dh_auto_build -Bbuild-32-shared
	dh_auto_build -Bbuild-32-static
	dh_auto_build -Bbuild-32-pic
ifeq (64,$(DEB_HOST_ARCH_BITS))
	dh_auto_build -Bbuild-64-shared
	dh_auto_build -Bbuild-64-static
	dh_auto_build -Bbuild-64-pic
endif

override_dh_auto_build-indep:

override_dh_auto_test-arch:
	dh_auto_test -Bbuild-32-shared
ifeq (64,$(DEB_HOST_ARCH_BITS))
	dh_auto_test -Bbuild-64-shared
endif

override_dh_auto_test-indep:

override_dh_auto_install-arch:
	dh_auto_install -Bbuild-32-shared
	dh_auto_install -Bbuild-64-shared
	cp build-32-static/lib/libslicot.a debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/
	cp build-32-pic/lib/libslicot.a debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libslicot_pic.a
ifeq (64,$(DEB_HOST_ARCH_BITS))
	cp build-64-static/lib/libslicot64.a debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/
	cp build-64-pic/lib/libslicot64.a debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libslicot64_pic.a
endif

override_dh_auto_install-indep:

override_dh_auto_clean:
	dh_auto_clean -Bbuild-32-shared
	dh_auto_clean -Bbuild-32-static
	dh_auto_clean -Bbuild-32-pic
ifeq (64,$(DEB_HOST_ARCH_BITS))
	dh_auto_clean -Bbuild-64-shared
	dh_auto_clean -Bbuild-64-static
	dh_auto_clean -Bbuild-64-pic
endif

override_dh_installchangelogs:
	dh_installchangelogs ReleaseNotes.md

=== debian/watch ===
Version: 5

Template: GitHub
Owner: SLICOT
Project: SLICOT-Reference
